- [Compiling sasa sources](#org30c5984)
- [Graph editor](#org350e6d3)
- [The Algo API](#orgf0dab07)
- [Demons](#org009ddc4)
- [Dealing with  Algorithm values](#org02f3ab5)
- [Representing Processes](#org889a969)
- [CLI arguments (sasa options)](#org83b3139)
- [The Main Simulation](#orge4efe80)
- [Generating Version Numbers](#orgd3a1891)
- [Pluging `sasa` on Synchronous tools](#org20e7801)
  - [RIF](#org286d056)
  - [The rdbg plugin](#org769e7a6)

Self-stabilizing Algorithms SimulAtor (Simulation d'Algorithmes autoStAbilisants)

Contributors Guide


<a id="org30c5984"></a>

# Compiling sasa sources

You will need:

-   make
-   a set of tools installable via opam
    -   dune
    -   ocamlgraph
    -   lutin (not for compiling actually, but for using sasa with custom demons)

cf the test job in the Gitlab CI script: <../../.gitlab-ci.yml> for a working installation process.


<a id="org350e6d3"></a>

# Graph editor

Based on dot + custom fields (algo, init) <../../lib/sasacore/topology.mli> <../../lib/sasacore/topology.ml>

This module is also used from `rdbg` (<../../test/rdbg-utils/dot.ml>)


<a id="orgf0dab07"></a>

# The Algo API

<../../lib/algo/algo.mli> <../../lib/algo/algo.ml>

Functions registration is based on Dynlink + (Hash)tables

Users only need to see the [mli](../../lib/algo/algo.mli) file.


<a id="org009ddc4"></a>

# Demons

built-in + custom

<../../lib/sasacore/demon.mli> <../../lib/sasacore/demon.ml>

custom in Lutin that can generated by:

<../../lib/sasacore/genLutin.mli> <../../lib/sasacore/genLutin.ml>


<a id="org02f3ab5"></a>

# Dealing with  Algorithm values

<../../lib/sasacore/env.mli> <../../lib/sasacore/env.ml>


<a id="org889a969"></a>

# Representing Processes

<../../lib/sasacore/process.mli>


<a id="org83b3139"></a>

# CLI arguments (sasa options)

<../../lib/sasacore/sasArg.mli> <../../lib/sasacore/sasArg.ml>


<a id="orge4efe80"></a>

# The Main Simulation

Splitted into 2 modules, so that the sasa rdbg plugin can reuse the step functions <../../lib/sasacore/sasa.ml>

<../../src/sasaMain.ml>


<a id="orgd3a1891"></a>

# Generating Version Numbers

The <../../lib/sasacore/sasaVersion.ml> is automatically generated

-   by <../../Makefile.version>
-   using git tags that are automatically generated using the `release` job of the CI script, which is based on [semantic-release-gitlab](https://www.npmjs.com/package/semantic-release-gitlab)

In order to generate sensible version numbers, please follow in your commit messages the conventions described here: <https://www.npmjs.com/package/conventional-changelog-eslint>

This also permits to generate some Releases Notes: <https://gricad-gitlab.univ-grenoble-alpes.fr/verimag/synchrone/sasa/releases>


<a id="org20e7801"></a>

# Pluging `sasa` on Synchronous tools


<a id="org286d056"></a>

## RIF

<http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lustre-v6/#outline-container-sec-5>

```ocaml
(* Time-stamp: <modified the 13/03/2019 (at 17:45) by Erwan Jahier> *)

(** Reads on stdin a bool *)

val bool: bool -> Process.t -> string -> bool
```

<../../lib/sasacore/rifRead.mli> <../../lib/sasacore/rifRead.ml>


<a id="org769e7a6"></a>

## The rdbg plugin

<https://gricad-gitlab.univ-grenoble-alpes.fr/verimag/synchrone/rdbg/blob/master/src/rdbgPlugin.mli> <https://gricad-gitlab.univ-grenoble-alpes.fr/verimag/synchrone/lutils/blob/master/src/data.mli>

<../../test/rdbg-utils/dot.ml>
