- [Dot files](#org8fd8577)
- [Algorithms](#orgcbbf32f)
- [Simulation](#org996e21a)
- [Custom mode](#orgd85b8c1)
- [rdbg](#orgc83f02b)
- [Releases Notes](#org56e1efd)
- [Installation (not yet working)](#orgf1a43f7)

Basically, one needs to provide

1.  a dot file
2.  the algorithms mentionned in the dot file


<a id="org8fd8577"></a>

# Dot files

Dot files should

1.  follow the [graphviz/dot format](https://en.wikipedia.org/wiki/DOT_(graph_description_language)).
2.  contain nodes labelled by the `algo` field

```dot
graph ring {
 p1 [algo="some_algo.cmxs"]
 p2 [algo="some_algo.cmxs"]
 p3 [algo="some_algo.cmxs"]
 p4 [algo="some_algo.cmxs"]
 p5 [algo="some_algo.cmxs"]
 p6 [algo="some_algo.cmxs"]
 p7 [algo="some_algo.cmxs"]

 p1 -- p2 -- p3 -- p4 -- p5 -- p6 -- p7 -- p1 
}
```


<a id="orgcbbf32f"></a>

# Algorithms

Those algorithms must provide:

1.  a set of variables (registers)
2.  an `enable` fonction that says which actions are enabled (i.e., that can be activated)
3.  a `step` function that executes enabled actions

More precisely, each algorithm should provide 3 functions that must be registred using the string used in dot file algo fields with:

-   `reg_vars`
-   `reg_enable`
-   `reg_step`

which profiles is defined in [algo.mli](https://gricad-gitlab.univ-grenoble-alpes.fr/verimag/synchrone/sasa/blob/master/lib/algo/algo.mli)

One can also register a function that provides initial values to local variables (`reg_init`). If not such registration is done, local variables will be set according to `init` annotations in the dot file. If no such annotations exists, initial values will be chosen at random.

```dot
graph ring {
 p1 [algo="some_algo.cmxs" init="v=1" init="x=3"]
 p2 [algo="some_algo.cmxs"]
 p3 [algo="some_algo.cmxs"]
 p4 [algo="some_algo.cmxs"]
 p5 [algo="some_algo.cmxs"]
 p6 [algo="some_algo.cmxs"]
 p7 [algo="some_algo.cmxs"]

 p1 -- p2 -- p3 -- p4 -- p5 -- p6 -- p7 -- p1 
}
```

Algorithms must then be compiled with `ocamlopt -shared` to produce the cmxs files mentionned in the dot file algo fields.

```sh
ocamlopt -shared -I +sasa some_algo.ml -o some_algo.cmxs
```

Some examples can be found in the [test](https://gricad-gitlab.univ-grenoble-alpes.fr/verimag/synchrone/sasa/tree/master/test) directory.


<a id="org996e21a"></a>

# Simulation

```sh
sasa some_topo.dot
sasa --help
```


<a id="orgd85b8c1"></a>

# Custom mode

For using the custom mode, it is mandatory to register actions


<a id="orgc83f02b"></a>

# rdbg


<a id="org56e1efd"></a>

# Releases Notes

<https://gricad-gitlab.univ-grenoble-alpes.fr/verimag/synchrone/sasa/releases>


<a id="orgf1a43f7"></a>

# Installation (not yet working)

```sh
# optional
opam repo add verimag-sync-repo "http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/opam-repository"
opam update -y
opam depext -y sasa
opam install -y sasa
```

Once is is done, upgrading to the last version of the tools is as simple as:

```yaml
opam update
opam upgrade
```
