(* Time-stamp: <modified the 28/03/2019 (at 18:01) by Erwan Jahier> *)

type t =
  | Synchronous (* select all actions *) 
  | Central (* select 1 action *)
  | LocallyCentral (* never activates two neighbors actions in the same step *)
  | Distributed (* select at least one action *)
  | Custom

(** At the inner list level, exactly one action is chosen.  At the
   outter list level, the number of chosen actions depends on the kind
   of demons.

    nb: only the Demon.custom mode may contain empty list, which
   happens if no rule is enabled in the corresponding process 

    In custom mode, also returns the rif values read on stdin
    (returns the empty string in other modes).

f dummy_input verbose_mode demon pl all enab
*)

type pna = Process.t * Topology.neighbor list * Algo.action
val f : bool -> bool -> t -> Process.t list -> pna list list -> bool list list ->
  string * pna list

