open Sasacore
open Sasa

let rec (simuloop: int -> int -> SasArg.t -> Process.t list -> string -> 
         (Process.t * Topology.neighbor list) list -> Env.t -> unit) =
  fun n i args pl activate_val pl_n e ->

    let ne, next_activate_val = simustep n i args pl activate_val pl_n e in
    if i > 0 then simuloop n (i-1) args pl next_activate_val pl_n ne else (
      if args.rif then (
        print_string "#q\n"; flush stdout
      ))

let () =
  let args, pl, pl_n, e = Sasa.make Sys.argv in
  try
    let n = args.length in
    simuloop n n args pl "" pl_n e
  with
  | Failure msg -> Printf.printf "Error: %s\n" msg
  | Silent i ->
    let str = if args.rif then "#" else "" in
    Printf.printf "%sThis algo is silent after %i steps\n" str i ;
    flush stdout;
    if args.rif && args.demon = Custom then (
      print_string "#q\n"; flush stdout
    )
