(* Time-stamp: <modified the 20/03/2019 (at 13:18) by Erwan Jahier> *)

(* This is algo 3.1 in the book *)

open Algo

let vars = ["c",It]
let k=3

let (init_vars: neighbor list -> local_env) =
  fun _nl ->
    function _ -> I (Random.int k)


let (used : neighbor list -> Algo.value list) = fun nl -> 
  let res = List.map (fun n -> n.lenv "c") nl in
  res

let (free : neighbor list -> Algo.value list) = fun nl ->
  let used_list = List.sort_uniq compare (used nl) in
  let rec aux free used i =
    if i > k then free else
      (match used with
       | x::tail -> if x = I i then aux free tail (i+1) else aux ((I i)::free) used (i+1)
       | [] -> aux ((I i)::free) used (i+1)
      )
  in
  let res = aux [] used_list 0 in
  List.rev res

let (enable_f:neighbor list -> local_env -> action list) =
  fun nl e ->
    if List.mem (e "c") (used nl) then ["conflict"] else []
  
let (step_f : neighbor list -> local_env -> action -> local_env) =
  fun nl e ->
    function  | _ -> (function "c" -> List.hd (free nl) | _ -> assert false)

let () =
  let algo_id = "p" in
  Algo.reg_actions   algo_id ["conflict"];
  Algo.reg_vars      algo_id vars;
  Algo.reg_init_vars algo_id init_vars; 
  Algo.reg_enable    algo_id enable_f;
  Algo.reg_step      algo_id step_f;
  ()

