(* Time-stamp: <modified the 29/03/2019 (at 14:20) by Erwan Jahier> *)

(* cf Collin-Dolex-94 *)

open Algo

let delta=10
let vars = ["path",(At (It,delta)) ]
let actions = ["a"]

let (init_vars: neighbor list -> local_env) =
  fun nl -> function
  | "path" -> A (Array.make delta (I (-1)))
  | _ -> raise Not_found
    
(* casting *)

let (enable_f:neighbor list -> local_env -> action list) =
  fun _nl e ->
    if (e "path") = A (Array.make delta (I (-1))) then [] else ["a"]

   
let (step_f : neighbor list -> local_env -> action -> local_env) =
  fun nl e -> 
    function
    | "a" -> (
        function
        | "path" -> A (Array.make delta (I (-1)))
        | o -> e o
      )
    | _ -> assert false

let () =
  let algo_id = "root" in
  Algo.reg_vars      algo_id vars;
  Algo.reg_init_vars algo_id init_vars; 
  Algo.reg_enable    algo_id enable_f;
  Algo.reg_step      algo_id step_f;
  Algo.reg_actions   algo_id actions;
  ()

