(* Time-stamp: <modified the 20/03/2019 (at 13:09) by Erwan Jahier> *)

open Algo
  
let vars = ["v",It]
let k=42

let (init_vars: neighbor list -> local_env) =
  fun _nl ->
    function _ -> I (Random.int k)

let (enable_f:neighbor list -> local_env -> action list) =
  fun nl e ->
    let pred = List.hd nl in
    if e "v" = pred.lenv "v" then ["a"] else []

let i e v = match e v with I i -> i | _ -> failwith "type error"

let (step_f : neighbor list -> local_env -> action -> local_env) =
  fun nl e ->
    function
    | _ ->
      let vv = i e "v" in
      (function "v" -> I ((vv +1) mod k) | _ -> assert false)

let () =
  let algo_id = "ringroot" in
  Algo.reg_actions   algo_id ["a"];
  Algo.reg_vars      algo_id vars;
  Algo.reg_init_vars algo_id init_vars;
  Algo.reg_enable    algo_id enable_f;
  Algo.reg_step      algo_id step_f;
  ()
